/* This is a script for Deluxe Mandelbrot  THOR.
   It generates the startup-picture and saves it to the
   program directory.
   You should call this macro to build the startup-picture.
   Updated for versions 1.10 and above
*/
   

lockgui

/* clear all */

new

/* The line feed character */
lf=x2c('0a')

/* Notify the user about the purpose of this macro.
   Note the double quotes allow spaces in the arguments */
   
requestnotify '"This macro generates' || lf || 'the startup picture."'

requestnotify '"Please select first' || lf || 'your prefered monitor."'

/* Let the user choice her prefered screenmode, default is EHB noninterlaced.
   Note that the name of the variable to put the settings into must be
   given in QUOTES... */

requestscreen 320 256 6 128+4 'monitor'


/* The stem variable monitor contains now the settings.
   Now adjust the screen, if user says O.K. */
   
if monitor.width>0 then do
        
 monitor monitor.width monitor.height monitor.depth monitor.modeid

/* Disable the requesters */

 offverify

/* The monitor is open now. Reset the parameters to defaults :
   first get the defaults */

 rangedefaults mandelbrot 'defaults'

/* and set them */
 setscreenparms 'defaults'

/* get processor and set to default */

 suggestprocessor 'proc'
 setprocessor proc

/* remove the dragbar */
 menuselected prefs dragbar 'drag'
 if drag=TRUE then
  menu prefs dragbar
  
/* now we're ready to calculate */

 menu project start

/* and wait for completion */

 waitcomplete
 
/* and now save this */

/* we must enable verification now, or all requesters are disabled */

 onverify
 saveas 'Startup.mdl'
 
/* we're done... */
 
 requestnotify '"Generation finished."'
 
end
unlockgui

